<?php

${basename(__FILE__, '.php')} = function() {
    if (
     $this->get_request_method() == "POST" 
     and $this->isAuthenticated() and
     isset($this->_request['firstname']) or
     isset($this->_request['lastname']) or 
     isset($this->_request['phoneno']) or 
     isset($this->_request['gender']) or 
     isset($this->_request['bio']) or 
     isset($this->_request['profile']) or 
     isset($this->_request['dob'])
     ) 
     {
        try {
            $new = new Userprofile();
            if (isset($this->_request['firstname'])) {
                $new->setFirstname($this->_request['firstname']);
            }
            if (isset($this->_request['lastname'])) {
                $new->setLastname($this->_request['lastname']);
            }
            if (isset($this->_request['phoneno'])) {
                $new->setPhoneno($this->_request['phoneno']);
            }
            if (isset($this->_request['gender'])) {
                $new->setGender($this->_request['gender']);
            }
            if (isset($this->_request['bio'])) {
                $new->setBio($this->_request['bio']);
            }
            if (isset($this->_request['profile'])) {
                $new->setProfile($this->_request['profile']);
            }
            if (isset($this->_request['dob'])) {
                $new->setDob($this->_request['dob']);
            }
            

            $data = [
                "id" => $new->getId(),
                "firstname" => $new->getFirstname(),
                "lastname" => $new->getLastname(),
                "phoneno" => $new->getMobileno(),
                "gender"=> $new->getGender(),
                "bio" => $new->getBio(),
                "profile" => $new->getProfile(),
                "DOB" => $new->getDob(),
            ];
            $this->response($this->json($data), 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage()
            ];
            $this->response($this->json($data), 403);
        }
    } else {
        $data = [
            "error" => "Bad request"
        ];
        $this->response($this->json($data), 400);
    }
};
