<?php
require $_SERVER['DOCUMENT_ROOT'] . '/../vendor/autoload.php';

// Import PHPMailer classes into the global namespace
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

/**
 * the purpose this class is to signup the user
 */
class signup
{
    public $username;
    public $password;
    public $email;
    private $db;
    private $user_id;
    public $token;

    public function __construct($username, $password, $email)
    {
        $this->username = $username;
        $this->password = $password;
        $this->email = $email;
        $this->password = password_hash($password, PASSWORD_DEFAULT);
        $this->db = database::getconnection();
        $this->token = auth::generateRandomHash(16);
        if ($this->userexits($username)) {
            throw new Exception("User exits");
        }

        $query = "INSERT INTO `auth` (`username`, `password`, `email`,`createdat`,`active`,`role`,`token`)
                    VALUES ('$username', '$this->password', '$email', now(),'0','user','$this->token');";

        $result =  $this->db->query($query);
        if (!$result) {
            throw new Exception("Error: " . $this->db->error);
        } else {
            $this->user_id = $this->db->insert_id;
            $this->sendVerification();
        }
    }

    public function getinsertid()
    {
        return $this->user_id;
    }


    public function sendVerification()
    {

        // Create an instance; passing `true` enables exceptions
        $mail = new PHPMailer(true);
        $config_path = file_get_contents($_SERVER['DOCUMENT_ROOT'].'/../project/userconfig.json');
        $get_config = json_decode($config_path,true);

        try {
            // Server settings
            $mail->isSMTP();                                            // Send using SMTP
            $mail->Host       = 'smtp.gmail.com';                     // Set the SMTP server to send through
            $mail->SMTPAuth   = true;                                   // Enable SMTP authentication
            $mail->Username   = 'email2sanjayv@gmail.com';              // SMTP username
            $mail->Password   = $get_config['email_password_key'];      // SMTP password
            $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            // Enable implicit TLS encryption
            $mail->Port       = 465;                                    // TCP port to connect to

            // Recipients
            $mail->setFrom('email2sanjayv@gmail.com', 'Sanjay');
            $mail->addAddress($this->email, $this->username);           // Add a recipient

            // Content
            $mail->isHTML(true);                                        // Set email format to HTML
            $mail->Subject = 'Email Verification';
            $mail->Body    = "Please click the link to verify your email: <a href=\"https://apis.zeal.ninja/verify?token={$this->token}\">Verify Email</a>";
            $mail->AltBody = "Please click the link to verify your email: https://apis.zeal.ninja/verify?token={$this->token}";

            $mail->send();
        } catch (Exception $e) {
            echo "Message could not be sent. Mailer Error: {$mail->ErrorInfo}";
        }
    }
    public function userexits($username)
    {
        $query =   "SELECT * FROM `auth` WHERE `username` = '$username';";

        $this->db = database::getconnection();
        $result = $this->db->query($query);

        if ($result->num_rows > 0) {
            return true;
        } else {
            return false;
        }
    }

    public static function verifyAccount($token)
    {
        $query = "SELECT * FROM auth WHERE token='$token';";
        $db = database::getConnection();
        $result = $db->query($query);
        if ($result->num_rows > 0) {
            $data = $result->fetch_assoc();
            if ($data['active'] == 1) {
                throw new Exception("Already Verified");
            }
            $db->query("UPDATE `auth` SET `active` = '1' WHERE (`token` = '$token');");
            return true;
        } else {
            return false;
        }
    }

}
