<?php

${basename(__FILE__, '.php')} = function()
{
    if (
        $this->get_request_method() == "POST" and
        isset($this->_request["username"]) and
        isset($this->_request["password"])
    ) {
        try {
            $userobj = new auth(
                $this->_request["username"],
                $this->_request["password"]
            );
            $data = [
                "message" => "signin successful",
                "tokens" => $userobj->getAuthTokens()
            ];
            $data = $this->json($data);
            $this->response($data, 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage(),
            ];

            $data = $this->json($data);
            $this->response($data, 406);
        }
    } else {
        $data = [
            "status" => "bad_request",
        ];
        $data = $this->json($data);
        $this->response($data, 400);
    }
};