<?php

${basename(__FILE__, '.php')} = function(){
    if($this->isAuthenticated()){
        try{
            $acc = new Account();
            $data = [
                "status" => $acc->logout(),
            ];
            $data = $this->json($data);
            $this->response($data, 200);
        } catch(Exception $e){
            $data = [
                "error" => $e->getMessage()
            ];
            $data = $this->json($data);
            $this->response($data, 403);
        }

    } else {
        $data = [
            "error" => "Bad request"
        ];
        $data = $this->json($data);
        $this->response($data, 400);
    }
};
