<?php

${basename(__FILE__, '.php')} = function()
{
    if (
        $this->get_request_method() == "POST" and
        isset($this->_request["username"]) and
        isset($this->_request["password"]) and
        isset($this->_request["email"])
    ) {
        try {
            $userobj = new signup(
                $this->_request["username"],
                $this->_request["password"],
                $this->_request["email"]
            );
            $data = [
                "message" => "signup successful",
                "userid" => $userobj->getinsertid(),
            ];
            $data = $this->json($data);
            $this->response($data, 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage(),
            ];

            $data = $this->json($data);
            $this->response($data, 409);
        }
    } else {
        $data = [
            "status" => "bad_request",
        ];
        $data = $this->json($data);
        $this->response($data, 400);
    }
};