<?php

${basename(__FILE__, '.php')} = function () {
    if ($this->isAuthenticated() && isset($this->_request['id']) and !empty(trim($this->_request['id']))) {
        try {
            $accid = $this->_request['id'];
            $new = new Account($accid);
            $data = [
                "status" => $new->deleteAccount()
            ];
            $this->response($this->json($data), 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage()
            ];
            $this->response($this->json($data), 403);
        }
    } else {
        $data = [
            "error" => "Bad request" . $this->_request["id"]
        ];
        $this->response($this->json($data), 400);
    }
};
