<?php

${basename(__FILE__, '.php')} = function() {
    if ($this->isAuthenticated()) 
     {
        try {
            $new = new Account();
            $data = [
                "id" => $new->getId(),
                "username" => $new->getUsername(),
                "Email" => $new->getEmail(),
                "Created_at" => $new->getCreated_at(),
                "Active"=> $new->getActive(),
                "Role" => $new->getRole(),
            ];
            $this->response($this->json($data), 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage()
            ];
            $this->response($this->json($data), 403);
        }
    } else {
        $data = [
            "error" => "Bad request"
        ];
        $this->response($this->json($data), 400);
    }
};
