<?php

${basename(__FILE__, '.php')} = function() {
    if ($this->isAuthenticated()) 
     {
        try {
            $new = new Userprofile();
            $data = [
                "id" => $new->getId(),
                "firstname" => $new->getFirstname(),
                "lastname" => $new->getLastname(),
                "phoneno" => $new->getMobileno(),
                "gender"=> $new->getGender(),
                "bio" => $new->getBio(),
                "profile" => $new->getProfile(),
                "DOB" => $new->getDob(),
            ];
            $this->response($this->json($data), 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage()
            ];
            $this->response($this->json($data), 403);
        }
    } else {
        $data = [
            "error" => "Bad request"
        ];
        $this->response($this->json($data), 400);
    }
};
