<?php

${basename(__FILE__, '.php')} = function() {
    if (
     $this->get_request_method() == "POST" 
     and $this->isAuthenticated() and
     isset($this->_request['firstname']) and
     isset($this->_request['lastname']) and 
     isset($this->_request['phoneno']) and 
     isset($this->_request['gender']) and 
     isset($this->_request['bio']) and 
     isset($this->_request['profile']) and 
     isset($this->_request['dob'])
     ) 
     {
        try {
            $new = new Userprofile();
            $firstname =$this->_request['firstname'];
            $lastname = $this->_request['lastname'];
            $phoneno = $this->_request['phoneno']; 
            $gender =  $this->_request['gender'];
            $bio =  $this->_request['bio']; 
            $profile = $this->_request['profile']; 
            $dob = $this->_request['dob'];
            $new->new($firstname,$lastname,$phoneno,$gender,$bio,$profile,$dob);
            $data = [
                "id" => $new->getId(),
                "firstname" => $new->getFirstname(),
                "lastname" => $new->getLastname(),
                "phoneno" => $new->getMobileno(),
                "gender"=> $new->getGender(),
                "bio" => $new->getBio(),
                "profile" => $new->getProfile(),
                "DOB" => $new->getDob(),
            ];
            $this->response($this->json($data), 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage()
            ];
            $this->response($this->json($data), 403);
        }
    } else {
        $data = [
            "error" => "Bad request"
        ];
        $this->response($this->json($data), 400);
    }
};
