<?php

${basename(__FILE__, '.php')} = function() {
    if ($this->get_request_method() == "POST" && $this->isAuthenticated() && isset($this->_request['id']) && isset($this->_request['role'])) {
        try {
            $id = $this->_request['id'];
            $role = $this->_request['role'];
            $roleHandler = new RoleHandler();
            $message = $roleHandler->changeRole($id, $role);
            $data = [
                "message" => $message,
            ];
            $this->response($this->json($data), 200);
        } catch (Exception $e) {
            $data = [
                "error" => $e->getMessage()
            ];
            $this->response($this->json($data), 403);
        }
    } else {
        $data = [
            "error" => "Bad request"
        ];
        $this->response($this->json($data), 400);
    }
};
