<?php

class RoleHandler {
    private $db;

    public function __construct() {
        $this->db = Database::getConnection();
        $this->checkPermission();
    }

    private function checkPermission() {
        if (!isset($_SESSION['username'])) {
            throw new Exception("User not authenticated");
        }

        $username = $_SESSION['username'];
        $query = "SELECT * FROM `auth` WHERE `username` = '$username'";
        $result = $this->db->query($query);

        if ($result->num_rows == 1) {
            $data = $result->fetch_assoc();
            if ($data["role"] !== "admin") {
                throw new Exception("Unauthorized");
            }
        } else {
            throw new Exception("User not found" .$username);
        }
    }


    public function changeRole($userid, $role="user") {
        $query = "UPDATE auth SET role = '$role' WHERE id = '$userid'";
        $result = $this->db->query($query);

        if ($result) {
            return "Role updated successfully";
        } else {
            throw new Exception("Cannot update role");
        }
    }
}
