<?php

require_once($_SERVER['DOCUMENT_ROOT']."/api/lib/database.class.php");

    try {
        // Get token from the URL and password from the POST request
        $token = isset($_GET['token']) ? $_GET['token'] : null;
        $password = isset($_POST['password']) ? $_POST['password'] : null;

        if ($token === null || $password === null) {
            throw new Exception("Token and password are required.");
        }

        $db = database::getconnection();
        $query = "SELECT user_id FROM password_resets WHERE token = '$token' AND expires_at > NOW()";
        $result = $db->query($query);

        if ($result->num_rows == 0) {
            throw new Exception("Invalid or expired token.");
        }

        $data = $result->fetch_assoc();
        $hashed_password = password_hash($password, PASSWORD_DEFAULT);
        $userid = $data['user_id'];

        // Update the password
        $update_query = "UPDATE auth SET password = '$hashed_password' WHERE id = '$userid'";
        if ($db->query($update_query)) {
            echo "Password reset successfully.";
        } else {
            throw new Exception("Failed to reset password.");
        }

        // Delete the token
        $delete_query = "DELETE FROM password_resets WHERE token = '$token'";
        $db->query($delete_query);
    } catch (Exception $e) {
        echo $e->getMessage();
    }

